Loading...
Searching...
No Matches
Sip_date

## Data Structures

struct | sip_date_s
| Structure for Date header. More...

## Macros

#define | sip_date(sip)
| Access a SIP Date header structure sip_date_t from sip_t.
#define | SIP_DATE_INIT()
| Initializer for structure sip_date_t.
#define | SIPTAG_DATE(x)
| Tag list item for pointer to a Date header structure sip_date_t.
#define | SIPTAG_DATE_REF(x)
| Tag list item for reference to a Date header pointer.
#define | SIPTAG_DATE_STR(s)
| Tag list item for string with Date header value.
#define | SIPTAG_DATE_STR_REF(x)
| Tag list item for reference to a Date header string.

## Typedefs

typedef struct sip_date_s | sip_date_t
| @

## Functions

issize_t | sip_date_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Date header.
issize_t | sip_date_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Date header.
sip_date_t * | sip_date_init (sip_date_t x[1])
| Initialize a structure sip_date_t.
int | sip_is_date (sip_header_t const *header)
| Test if header object is instance of sip_date_t.
sip_date_t * | sip_date_dup (su_home_t *home, sip_date_t const *hdr))
| Duplicate a list of Date header header structures sip_date_t.
sip_date_t * | sip_date_copy (su_home_t *home, sip_date_t const *hdr))
| Copy a list of Date header header structures sip_date_t.
sip_date_t * | sip_date_make (su_home_t *home, char const *s))
| Make a Date header structure sip_date_t.
sip_date_t * | sip_date_format (su_home_t *home, char const *fmt,...)))
| Make a Date header from formatting result.
sip_date_t * | sip_date_create (su_home_t *home, sip_time_t date)
| Create an Date header object.

## Variables

msg_hclass_t | sip_date_class []
| Header class for Date header.
tag_typedef_t | siptag_date
| Tag for Date header object.
tag_typedef_t | siptag_date_str
| Tag for string with Date header value.

## Detailed Description

## Macro Definition Documentation

## SIP_DATE_INIT

#define SIP_DATE_INIT | ( |  | ) |

Initializer for structure sip_date_t.

A static sip_date_t structure for Date header must be initialized with the SIP_DATE_INIT() macro. For instance,

sip_date_t sip_date = SIP_DATE_INIT;
SIP_DATE_INIT
#define SIP_DATE_INIT()
Initializer for structure sip_date_t.
Definition sip_protos.h:4432
sip_date_t
struct sip_date_s sip_date_t
@
Definition sip.h:157
sip_date
#define sip_date(sip)
Access a SIP Date header structure sip_date_t from sip_t.
Definition sip_protos.h:4415

## SIPTAG_DATE

#define SIPTAG_DATE | ( |  | x | ) |

Tag list item for pointer to a Date header structure sip_date_t.

The SIPTAG_DATE() macro is used to include a tag item with a pointer to a sip_date_t structure in a tag list.

Parameters

  x | pointer to a sip_date_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_DATE_REF().

## SIPTAG_DATE_STR

#define SIPTAG_DATE_STR | ( |  | s | ) |

Tag list item for string with Date header value.

The SIPTAG_DATE_STR() macro is used to include a tag item with a string containing value of a sip_date_t header in a tag list.

Parameters

  s | pointer to a string containing Date header value, or NULL.

The string in SIPTAG_DATE_STR() can be converted to a sip_date_t header structure by giving the string s has second argument to function sip_date_make().

The corresponding tag taking reference parameter is SIPTAG_DATE_STR_REF().

## Typedef Documentation

## sip_date_t

typedef struct sip_date_s sip_date_t

@

The Date header field reflects the time when the request or response was first sent. Its syntax is defined in RFC 3261 and RFC 2616 section 14.18 as follows:

Date = "Date" HCOLON SIP-date
SIP-date = rfc1123-date
rfc1123-date = wkday "," SP date1 SP time SP "GMT"
date1 = 2DIGIT SP month SP 4DIGIT
; day month year (e.g., 02 Jun 1982)
time = 2DIGIT ":" 2DIGIT ":" 2DIGIT
; 00:00:00 - 23:59:59
wkday = "Mon" / "Tue" / "Wed"
/ "Thu" / "Fri" / "Sat" / "Sun"
month = "Jan" / "Feb" / "Mar" / "Apr"
/ "May" / "Jun" / "Jul" / "Aug"
/ "Sep" / "Oct" / "Nov" / "Dec"
DIGIT
#define DIGIT
SP
#define SP

The parsed Date header is stored in sip_date_t structure.

The structure sip_date_t contains representation of SIP Date header.

The sip_date_t is defined as follows:

typedef struct sip_date_s {
sip_common_t d_common[1]; // Common fragment info
sip_date_t *d_next; // Link to next (dummy)
sip_time_t d_time; // Seconds since Jan 1, 1900
} sip_date_t;
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_time_t
msg_time_t sip_time_t
Time in seconds since Jan 01 1900.
Definition sip.h:105
sip_date_s
Structure for Date header.
Definition sip.h:514
sip_date_s::d_common
sip_common_t d_common[1]
Common fragment info.
Definition sip.h:515
sip_date_s::d_time
sip_time_t d_time
Seconds since Jan 1, 1900.
Definition sip.h:517
sip_date_s::d_next
sip_date_t * d_next
Link to next (dummy).
Definition sip.h:516

## Function Documentation

## sip_date_copy()

sip_date_t * sip_date_copy | ( | su_home_t * | home,
|  | sip_date_t const * | hdr )

inline

Copy a list of Date header header structures sip_date_t.

The function sip_date_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  date = sip_date_copy(home, sip->sip_date);
  sip_date_copy
  sip_date_t * sip_date_copy(su_home_t *home, sip_date_t const *hdr))
  Copy a list of Date header header structures sip_date_t.
  Definition sip_protos.h:4562

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_date_create()

sip_date_t * sip_date_create | ( | su_home_t * | home,
|  | sip_time_t | date )

Create an Date header object.

Create a Date header object with the date date. If

Date
  is 0, current time (as returned by sip_now()) is used.

Parameters

  home | memory home
  date | date expressed as seconds since Mon, 01 Jan 1900 00:00:00

Returns
  A pointer to newly created Date header object when successful, or NULL upon an error.

## sip_date_dup()

sip_date_t * sip_date_dup | ( | su_home_t * | home,
|  | sip_date_t const * | hdr )

inline

Duplicate a list of Date header header structures sip_date_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  date = sip_date_dup(home, sip->sip_date);
  sip_date_dup
  sip_date_t * sip_date_dup(su_home_t *home, sip_date_t const *hdr))
  Duplicate a list of Date header header structures sip_date_t.
  Definition sip_protos.h:4519

Returns
  A pointer to the newly duplicated sip_date_t header structure, or NULL upon an error.

## sip_date_format()

sip_date_t * sip_date_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Date header from formatting result.

Make a new sip_date_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_date_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_date_init()

sip_date_t * sip_date_init | ( | sip_date_t | x[1] | ) |

inline

Initialize a structure sip_date_t.

An sip_date_t structure for Date header can be initialized with the sip_date_init() function/macro. For instance,

sip_date_t sip_date;
sip_date_init(&sip_date);
sip_date_init
sip_date_t * sip_date_init(sip_date_t x[1])
Initialize a structure sip_date_t.
Definition sip_protos.h:4450

## sip_date_make()

sip_date_t * sip_date_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Date header structure sip_date_t.

The function sip_date_make() makes a new sip_date_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_date_t header structure, or NULL upon an error.

## sip_is_date()

int sip_is_date | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_date_t.

Check if the header class is an instance of Date header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header date
  0 | (false) otherwise

## Variable Documentation

## sip_date_class

msg_hclass_t sip_date_class[]

extern

Header class for Date header.

The header class sip_date_class defines how a SIP Date header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_date_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.